//------------------------------------------------------------------------------
//
//  Boule reloaded
//
//  Author: Bonsai (mail: bonsai@b0n541.net)
//
//  Copyright: GNU General Public License
//             dirt_large_seemless.jpg is copyrighted 
//             under the Blender Artistic License
//
//------------------------------------------------------------------------------

#include "metals.inc"     
#include "colors.inc"
#include "textures.inc"
#include "woods.inc"


#declare zf = seed(8475);

global_settings {
	
	ambient_light rgb <1.5, 1.5, 0.95>
}

camera {

	location <15, 15, 0>
	look_at <0, 0, 0>
	angle 45
}                
        
light_source {
	
	<0, 15, 0>
	color rgb <1, 1, 0.9>
	area_light x, z, 10, 10
	adaptive 3
}

light_source {
	
	<350, 500, -500>
	color rgb <1, 1, 0.9>
	adaptive 10
	shadowless
}

//von skies.inc
sky_sphere {
	
	pigment { 
		
		rgb <0.258, 0.258, 0.435> 
	}
    
	pigment {
		
		bozo
		turbulence 1.5
		octaves 10
		omega 0.5
		lambda 2.5
        
		color_map {
			
			[0.0, 0.5 color rgbf<0.75, 0.75, 0.75, 0.00>
					  color rgbf<0.90, 0.90, 0.90, 0.90> ]
			[0.5, 0.7 color rgbf<0.90, 0.90, 0.90, 0.90>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
			[0.7, 1.0 color rgbf<1.00, 1.00, 1.00, 1.00>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
		}
		
		scale <1, 0.3, 10>
	}

	pigment {

		bozo
		turbulence 0.6
		octaves 10
		omega 0.5
		lambda 2.5

		color_map {

			[0.0, 0.4 color rgbf<0.75, 0.75, 0.75, 0.00>
					  color rgbf<0.90, 0.90, 0.90, 0.90> ]
			[0.4, 0.7 color rgbf<0.90, 0.90, 0.90, 0.90>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
			[0.7, 1.0 color rgbf<1.00, 1.00, 1.00, 1.00>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
		}
		
		scale <1, 0.3, 10>
	}
	
	pigment {

		bozo
		turbulence 0.8
		octaves 10
		omega 0.5
		lambda 2.5

		color_map {
			
			[0.0, 0.4 color rgbf<0.75, 0.75, 0.75, 0.00>
					  color rgbf<0.90, 0.90, 0.90, 0.90> ]
			[0.4, 0.6 color rgbf<0.90, 0.90, 0.90, 0.90>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
			[0.6, 1.0 color rgbf<1.00, 1.00, 1.00, 1.00>
					  color rgbf<1.00, 1.00, 1.00, 1.00> ]
		}
		
		scale <1, 0.3, 10>
	}
}


// The ground
plane {

	<0, 1, 0>, 0

	texture {

		pigment {

			image_map {

				jpeg "dirt_large_seemless.jpg"
			}

			rotate <90, 0, 32>
			scale 10
		}
	}
}


#declare KR = 2; //radius of sphere
#declare RR = KR/50; //radius of stripe

#declare Boulekugel1 =
	difference {

		sphere {

			<0, 0, 0>, KR   
		}

		torus {

			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			translate <0, 1/3*KR, 0>
		}

		torus {
			
			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			translate <0, -1/3*KR, 0>
		}

		torus {

			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			rotate <0, 0, 90>
			translate <1/3*KR, 0, 0>
		}

		torus {

			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			rotate <0, 0, 90>
			translate <-1/3*KR, 0, 0>
		}

		torus {

			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, 1/3*KR>
		}

		torus {

			sqrt((2/3)*KR*(2*KR-(2/3)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, -1/3*KR>
		}
	}


#declare Boulekugel2 =
	difference {

		object {

			Boulekugel1
		}

		//second stripe
		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			translate <0, 4/10*KR, 0>
		}

		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			translate <0, -4/10*KR, 0>
		}

		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			rotate <0, 0, 90>
			translate <4/10*KR, 0, 0>
		}

		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			rotate <0, 0, 90>
			translate <-4/10*KR, 0, 0>
		}

		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, 4/10*KR>
		}

		torus {

			sqrt((3/5)*KR*(2*KR-(3/5)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, -4/10*KR>
		}
	}


#declare Boulekugel3 =
	difference {
	
		object {
	
			Boulekugel2
		}
	
		//third stripe
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			translate <0, 14/30*KR, 0>
		}
	
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			translate <0, -14/30*KR, 0>
		}
	
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			rotate <0, 0, 90>
			translate <14/30*KR, 0, 0>
		}
	
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			rotate <0, 0, 90>
			translate <-14/30*KR, 0, 0>
		}
	
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, 14/30*KR>
		}
	
		torus {
	
			sqrt((16/30)*KR*(2*KR-(16/30)*KR)), RR
			rotate <90, 0, 0>
			translate <0, 0, -14/30*KR>
		}
	}             


#declare BouleTexture =
    texture {

		T_Chrome_2B
		
		finish {

			roughness 3
			phong 0.5
			phong_size 20
			reflection 0.1
		}
	}


// The boule spheres
object {
	
	Boulekugel2
    
    texture {

		BouleTexture
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <0, 2, 0>
}


object {

	Boulekugel1

    texture {

		BouleTexture
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <5, 2, 4>
}        


object {
        
	Boulekugel2

    texture {

		BouleTexture
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <-4, 2, 1>
}


object {
        
	Boulekugel1

    texture {

		BouleTexture
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <-5, 2, -3>
}        


object {
        
	Boulekugel3

    texture {

		BouleTexture
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <3, 2, -6>
}


// The little wooden sphere
sphere {

	<0, 0, 0>, 0.75

	texture{
                
		T_Wood23

		finish {

			roughness 3
			phong 0.25
			phong_size 5
		}
	}

	rotate <rand(zf)*360, rand(zf)*360, rand(zf)*360>
	translate <5, 0.75, -3>
}
